
// code by volvox for hugi #14

#pragma inline  // direktive um rep movsd nutzen zu koennen
asm .486

void draw_sprite (unsigned int x,unsigned int y,char far sprite[],
		 int breite,int hoehe,char far *vs)
 {

int
    Rechts_Ueberstehend = 0,
     Links_Ueberstehend = 0,
     Sprung		= 0;

  //Prfe ob das Sprite berhaupt im sichtbaren Bereich liegt...
  asm mov ax,[y]
  asm cmp ax,200
  asm jnae Y_BORDER_OK
  asm mov cx,[hoehe]
  asm neg cx
  asm cmp ax,cx
  asm jnbe Y_BORDER_OK
  asm jmp sprite_is_out_of_range
Y_BORDER_OK:
  asm mov ax,[x]
  asm cmp ax,320
  asm jnae X_BORDER_OK
  asm mov cx,[breite]
  asm neg cx
  asm cmp ax,cx
  asm jnbe X_BORDER_OK
  asm jmp sprite_is_out_of_range
X_BORDER_OK:

  asm push ds                 // Datensegment sichern
  asm les di,[vs]             // DI zeigt auf den virtuellen Screen
  asm lds si,[sprite]         // SI zeigt auf die Spritedaten

  //Oben clippen (Y<0)
  asm mov ax,[y]
  asm or  ax,ax
  asm jnle kein_clip_oben
  asm neg ax                //Vorzeichen entfernen
  asm sub [hoehe],ax        //Hoehe verringern
  asm mov cx,[breite]
  asm mul cx
  asm add si,ax
  asm xor ax,ax
  asm mov [y],ax

kein_clip_oben:
  //Links clippen (X<0)
  asm mov ax,[x]
  asm or  ax,ax             //Linken Bildschirmrand berschritten ?
  asm jnle kein_clip_links
  asm neg ax
  asm sub [breite],ax             //Breite des Sprites verringern
  asm mov [Links_Ueberstehend],ax //links berstehende Pixel sichern
  asm xor ax,ax
  asm mov [x],ax

kein_clip_links:
  //Unten clippen (Y+Hoehe>200)
  asm mov ax,[y]
  asm add ax,[hoehe]
  asm cmp ax,200
  asm jna kein_clip_unten
  asm sub ax,200
  asm sub [hoehe],ax

kein_clip_unten:
  //Rechts clippen (X+Breite>320)
  asm mov ax,[x]
  asm add ax,[breite]
  asm cmp ax,320
  asm jna kein_clip_rechts
  asm sub ax,320
  asm sub [breite],ax
  asm mov [Rechts_Ueberstehend],ax

kein_clip_rechts:
  //Zeilensprung vorbereiten
  asm mov ax,320
  asm sub ax,[breite]
  asm mov [Sprung],ax
  //Position des Sprites auf dem Bildschirm berechnen (y*320+x)
  asm mov ax,[y]
  asm shl ax,2
  asm add ax,[y]
  asm shl ax,6
  asm add ax,[x]
  asm add di,ax

  asm mov cx,[hoehe]        //Hoehe des Sprites nach CX
yloop:
  asm add si,[Links_Ueberstehend]
  asm mov dx,[breite]               //Breite nach DX
xloop:
  asm lodsb                  //Pixel aus Spritearray lesen
  asm or  al,al              //Gehrt es zum Sprite ?
  asm je  setze_keinen_punkt //Nein also dieses Pixel bersprigen
  asm stosb                  //ansonsten Pixel setzen
  asm jmp xloop_continue
setze_keinen_punkt:
  asm inc di                //DI zeigt auf das nchste Byte im Sprite
xloop_continue:
  asm dec dx
  asm jnz xloop                     //Eine Zeile abarbeiten.
  asm add di,[Sprung]               //Nchste Zeile (320-Breite)
  asm add si,[Rechts_Ueberstehend]  //berstehende Pixel uebergehen
  asm dec cx
  asm jnz yloop
  asm pop ds                        // Datensegment restaurieren

sprite_is_out_of_range:

}

void pset (unsigned int x,unsigned int y,char c,char far *where)
 {
   asm mov ax,[x]
   asm cmp ax,319
   asm ja  skip_pset_routine
   asm mov ax,[y]
   asm cmp ax,199
   asm ja  skip_pset_routine
   asm push ds
   asm lds si,[where[0]]
   asm mov di,[y]
   asm shl di,2
   asm add di,[y]
   asm shl di,6
   asm add di,[x]
   asm add si,di
   asm mov al,c
   asm stosb
   asm pop ds
skip_pset_routine:
 }

void loesch_vs(char far *vs)
 {
  asm les di,vs
  asm mov cx,16000
  asm mov eax,0x00000000
  asm rep stosd
 }

void waitretrace()
 {
  //ein halber retrace reicht auch
  asm mov dx,0x3da
  w1:
  asm in al,dx
  asm and al,8
  asm jz w1

/*w2:
  asm in al,dx
  asm and al,8
  asm jnz w2
*/
 }

void copy_vs_2vga(char far *vs)
 {
  asm push ds
  asm mov ax,0xA000
  asm mov es,ax
  asm xor di,di
  asm lds si,[vs]
  asm mov cx,16000
  asm rep movsd
  asm pop ds
 }
